Loading...
Searching...
No Matches
Sip_request_disposition

## Data Structures

struct | sip_request_disposition_s
| Structure for Request-Disposition header. More...

## Macros

#define | sip_request_disposition(sip)
| Access a SIP Request-Disposition header structure sip_request_disposition_t from sip_t.
#define | SIP_REQUEST_DISPOSITION_INIT()
| Initializer for structure sip_request_disposition_t.
#define | SIPTAG_REQUEST_DISPOSITION(x)
| Tag list item for pointer to a Request-Disposition header structure sip_request_disposition_t.
#define | SIPTAG_REQUEST_DISPOSITION_REF(x)
| Tag list item for reference to a Request-Disposition header pointer.
#define | SIPTAG_REQUEST_DISPOSITION_STR(s)
| Tag list item for string with Request-Disposition header value.
#define | SIPTAG_REQUEST_DISPOSITION_STR_REF(x)
| Tag list item for reference to a Request-Disposition header string.

## Typedefs

typedef struct sip_request_disposition_s | sip_request_disposition_t
| @

## Functions

issize_t | sip_request_disposition_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Request-Disposition header.
issize_t | sip_request_disposition_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Request-Disposition header.
sip_request_disposition_t * | sip_request_disposition_init (sip_request_disposition_t x[1])
| Initialize a structure sip_request_disposition_t.
int | sip_is_request_disposition (sip_header_t const *header)
| Test if header object is instance of sip_request_disposition_t.
sip_request_disposition_t * | sip_request_disposition_dup (su_home_t *home, sip_request_disposition_t const *hdr))
| Duplicate a list of Request-Disposition header header structures sip_request_disposition_t.
sip_request_disposition_t * | sip_request_disposition_copy (su_home_t *home, sip_request_disposition_t const *hdr))
| Copy a list of Request-Disposition header header structures sip_request_disposition_t.
sip_request_disposition_t * | sip_request_disposition_make (su_home_t *home, char const *s))
| Make a Request-Disposition header structure sip_request_disposition_t.
sip_request_disposition_t * | sip_request_disposition_format (su_home_t *home, char const *fmt,...)))
| Make a Request-Disposition header from formatting result.

## Variables

msg_hclass_t | sip_request_disposition_class []
| Header class for Request-Disposition header.
tag_typedef_t | siptag_request_disposition
| Tag for Request-Disposition header object.
tag_typedef_t | siptag_request_disposition_str
| Tag for string with Request-Disposition header value.

## Detailed Description

## Macro Definition Documentation

## SIP_REQUEST_DISPOSITION_INIT

#define SIP_REQUEST_DISPOSITION_INIT | ( |  | ) |

Initializer for structure sip_request_disposition_t.

A static sip_request_disposition_t structure for Request-Disposition header must be initialized with the SIP_REQUEST_DISPOSITION_INIT() macro. For instance,

sip_request_disposition_t sip_request_disposition = SIP_REQUEST_DISPOSITION_INIT;
sip_request_disposition
#define sip_request_disposition(sip)
Access a SIP Request-Disposition header structure sip_request_disposition_t from sip_t.
Definition sip_protos.h:3463
SIP_REQUEST_DISPOSITION_INIT
#define SIP_REQUEST_DISPOSITION_INIT()
Initializer for structure sip_request_disposition_t.
Definition sip_protos.h:3480
sip_request_disposition_t
struct sip_request_disposition_s sip_request_disposition_t
@
Definition sip.h:179

## SIPTAG_REQUEST_DISPOSITION

#define SIPTAG_REQUEST_DISPOSITION | ( |  | x | ) |

Tag list item for pointer to a Request-Disposition header structure sip_request_disposition_t.

The SIPTAG_REQUEST_DISPOSITION() macro is used to include a tag item with a pointer to a sip_request_disposition_t structure in a tag list.

Parameters

  x | pointer to a sip_request_disposition_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REQUEST_DISPOSITION_REF().

## SIPTAG_REQUEST_DISPOSITION_STR

#define SIPTAG_REQUEST_DISPOSITION_STR | ( |  | s | ) |

Tag list item for string with Request-Disposition header value.

The SIPTAG_REQUEST_DISPOSITION_STR() macro is used to include a tag item with a string containing value of a sip_request_disposition_t header in a tag list.

Parameters

  s | pointer to a string containing Request-Disposition header value, or NULL.

The string in SIPTAG_REQUEST_DISPOSITION_STR() can be converted to a sip_request_disposition_t header structure by giving the string s has second argument to function sip_request_disposition_make().

The corresponding tag taking reference parameter is SIPTAG_REQUEST_DISPOSITION_STR_REF().

## Typedef Documentation

## sip_request_disposition_t

typedef struct sip_request_disposition_s sip_request_disposition_t

@

The Request-Disposition header syntax is defined in RFC 3841 section 10 as follows:

Request-Disposition = ( "Request-Disposition" | "d" ) HCOLON
directive *(COMMA directive)
directive = proxy-directive / cancel-directive /
fork-directive / recurse-directive /
parallel-directive / queue-directive)
proxy-directive = "proxy" / "redirect"
cancel-directive = "cancel" / "no-cancel"
fork-directive = "fork" / "no-fork"
recurse-directive = "recurse" / "no-recurse"
parallel-directive = "parallel" / "sequential"
queue-directive = "queue" / "no-queue"

The parsed Request-Disposition header is stored in sip_request_disposition_t structure.

The structure sip_request_disposition_t contains representation of Request-Disposition header.

The sip_request_disposition_t is defined as follows:

typedef struct sip_request_disposition_s
{
sip_common_t rd_common[1]; // Common fragment info
sip_unknown_t *rd_next; // Link to next (dummy)
msg_param_t *rd_items; // List of directives
} sip_request_disposition_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_request_disposition_s
Structure for Request-Disposition header.
Definition sip.h:645
sip_request_disposition_s::rd_next
sip_error_t * rd_next
Link to next (dummy).
Definition sip.h:647
sip_request_disposition_s::rd_common
sip_common_t rd_common[1]
Common fragment info.
Definition sip.h:646
sip_request_disposition_s::rd_items
msg_param_t * rd_items
List of directives.
Definition sip.h:648

## Function Documentation

## sip_is_request_disposition()

int sip_is_request_disposition | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_request_disposition_t.

Check if the header class is an instance of Request-Disposition header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header request_disposition
  0 | (false) otherwise

## sip_request_disposition_copy()

sip_request_disposition_t * sip_request_disposition_copy | ( | su_home_t * | home,
|  | sip_request_disposition_t const * | hdr )

inline

Copy a list of Request-Disposition header header structures sip_request_disposition_t.

The function sip_request_disposition_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  request_disposition = sip_request_disposition_copy(home, sip->sip_request_disposition);
  sip_request_disposition_copy
  sip_request_disposition_t * sip_request_disposition_copy(su_home_t *home, sip_request_disposition_t const *hdr))
  Copy a list of Request-Disposition header header structures sip_request_disposition_t.
  Definition sip_protos.h:3610

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_request_disposition_dup()

sip_request_disposition_t * sip_request_disposition_dup | ( | su_home_t * | home,
|  | sip_request_disposition_t const * | hdr )

inline

Duplicate a list of Request-Disposition header header structures sip_request_disposition_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  request_disposition = sip_request_disposition_dup(home, sip->sip_request_disposition);
  sip_request_disposition_dup
  sip_request_disposition_t * sip_request_disposition_dup(su_home_t *home, sip_request_disposition_t const *hdr))
  Duplicate a list of Request-Disposition header header structures sip_request_disposition_t.
  Definition sip_protos.h:3567

Returns
  A pointer to the newly duplicated sip_request_disposition_t header structure, or NULL upon an error.

## sip_request_disposition_format()

sip_request_disposition_t * sip_request_disposition_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Request-Disposition header from formatting result.

Make a new sip_request_disposition_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_request_disposition_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_request_disposition_init()

sip_request_disposition_t * sip_request_disposition_init | ( | sip_request_disposition_t | x[1] | ) |

inline

Initialize a structure sip_request_disposition_t.

An sip_request_disposition_t structure for Request-Disposition header can be initialized with the sip_request_disposition_init() function/macro. For instance,

sip_request_disposition_t sip_request_disposition;
sip_request_disposition_init(&sip_request_disposition);
sip_request_disposition_init
sip_request_disposition_t * sip_request_disposition_init(sip_request_disposition_t x[1])
Initialize a structure sip_request_disposition_t.
Definition sip_protos.h:3498

## sip_request_disposition_make()

sip_request_disposition_t * sip_request_disposition_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Request-Disposition header structure sip_request_disposition_t.

The function sip_request_disposition_make() makes a new sip_request_disposition_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_request_disposition_t header structure, or NULL upon an error.

## Variable Documentation

## sip_request_disposition_class

msg_hclass_t sip_request_disposition_class[]

extern

Header class for Request-Disposition header.

The header class sip_request_disposition_class defines how a SIP Request-Disposition header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_request_disposition_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.